// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular
  .module("starter", [
    "ionic",
    "ion-datetime-picker",
    "starter.controllers",
    "starter.services",
    "starter.constants",
    "timer",
    "ngCordova",
    "monospaced.elastic",
  ])

  .run(function (
    $ionicPlatform,
    $rootScope,
    $state,
    $ionicHistory,
    apiService,
    appService,
    cordovaService,
    appLogService,
    ngCordovaService,
    broadcastConstants,
    broadcastService,
    $http,
    apiConstants
  ) {
    $ionicPlatform.ready(function () {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (
        window.cordova &&
        window.cordova.plugins &&
        window.cordova.plugins.Keyboard
      ) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);
      }
      if (window.cordova && window.cordova.InAppBrowser) {
        window.open = window.cordova.InAppBrowser.open;
      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        StatusBar.styleDefault();
      }
      // 对部分private的API应添加用户检查
      var beCheckedStateNames = [];
      beCheckedStateNames.push("tab.myborrowed");
      beCheckedStateNames.push("orderconfirm");
      beCheckedStateNames.push("tab.myReserved");
      beCheckedStateNames.push("tab.return_book_orders");
      beCheckedStateNames.push("tab.activityworldmine");
      beCheckedStateNames.push("tab.activityCreate");
      beCheckedStateNames.push("tab.activityPatch");
      beCheckedStateNames.push("tab.minesettings");
      beCheckedStateNames.push("tab.youchooseipay");
      beCheckedStateNames.push("tab.mine_fans");
      beCheckedStateNames.push("tab.mine_follows");
      beCheckedStateNames.push("tab.dc_bookhome_book_leave_message");
      beCheckedStateNames.push("tab.mine_check_messages");
      beCheckedStateNames.push("tab.mine_check_messages");
      beCheckedStateNames.push("tab.mineChildren");

      // 对tab的第一个页面执行历史清除操作
      var historyCleanedStatenNames = [];
      historyCleanedStatenNames.push("tab.home");
      historyCleanedStatenNames.push("tab.dcbhdetail");
      historyCleanedStatenNames.push("tab.discovery");
      historyCleanedStatenNames.push("tab.mine");
      $rootScope.$on(
        "$stateChangeStart",
        function (event, toState, toParams, fromState, fromParams) {
          var stateName = toState.name;
          // check user
          var toCheck = false;
          for (var i = 0; i < beCheckedStateNames.length; i++) {
            if (stateName == beCheckedStateNames[i]) {
              toCheck = true;
              break;
            }
          }
          if (toCheck) {
            if (!$rootScope.user) {
              event.preventDefault();
              $state.go("tab.mine", { fromState: fromState }); // 先登录
              return;
            }
          }
          // clean history
          var toClean = false;
          for (var i = 0; i < historyCleanedStatenNames.length; i++) {
            if (stateName == historyCleanedStatenNames[i]) {
              toClean = true;
              break;
            }
          }
          //
          if (toClean) {
            //  $ionicHistory.clearHistory();
          }
        }
      );

      // 处理Android返回按键
      var maxExitInterval = 1000 * 3; // 最大二次点击返回按键退出间隔
      var lastBackButtionActionTimeInTabs = new Date();
      lastBackButtionActionTimeInTabs.setTime(
        lastBackButtionActionTimeInTabs.getTime() - maxExitInterval
      ); // 防止第一次点击返回按钮出现立即退出的情况，假设第0次（实际上不存在）发生在当前之前的某个时间。
      console.log(
        "for back button pressed. firstTime = " +
          lastBackButtionActionTimeInTabs.getTime()
      );
      $ionicPlatform.registerBackButtonAction(
        function (e) {
          var handled = false;
          var currentViewName = $ionicHistory.currentView().stateName;
          console.log(
            "on back button pressed. currentViewName = " + currentViewName
          );
          switch (currentViewName) {
            case "tab.home":
            case "tab.bookhome":
            case "tab.discovery":
            case "tab.mine":
              handled = true;
              var now = new Date();
              console.log("on back button pressed. now = " + now.getTime());
              if (
                now.getTime() - lastBackButtionActionTimeInTabs.getTime() <=
                maxExitInterval
              ) {
                ionic.Platform.exitApp();
              } else {
                ngCordovaService.showToast("再按一次返回键退出应用");
              }
              lastBackButtionActionTimeInTabs = now;
              e.preventDefault();
              break;
            case "depositPay":
            case "returnbook":
              handled = true;
              ngCordovaService.showToast("当前页面不允许执行返回操作");
              e.preventDefault();
              break;
            default:
              break;
          }
          if (!handled) {
            $ionicHistory.goBack();
          }
        },
        101 // Your back button action will override each of the above actions whose priority is less than the priority you provide. For example, an action assigned a priority of 101 will override the ‘return to previous view’ action, but not any of the other actions.
      );

      if (localStorage.getItem("reader_info")) {
        var data = JSON.parse(localStorage.getItem("reader_info"));
        //初始化还书的默认手机号
        $rootScope.returnTelephone = localStorage.getItem("defaultReturnTel");
        // 防止修改头像之后，重新登录，图像依然是原先的。
        if (data.photo_url) {
          data.photo_url = data.photo_url + "?t=" + new Date().getTime();
        }
        // 保存ALEPH的用户数据
        $rootScope.user = data;
        broadcastService.send(
          broadcastConstants.names.userInfoChange,
          $rootScope.user
        );
        //用户最大可借本数
        apiService.borrowCount($rootScope.user.account, {
          onSuccess: function (data, status, config, headers) {
            $rootScope.allowBorrowCount = data;
          },
        });
        // 获取用户信息
        apiService.getUserInfo($rootScope.user.account, {
          onSuccess: function (data, status, config, headers) {
            // 保存用户信息
            $rootScope.userInfo = data;
            // TODO 给更新url加上一个不存在的随机参数，让浏览器以为这是一个新的url。目的是，防止原有的头像url和新的头像url相同的时候，浏览器认为该url已经做了缓存，不再重新加载图片。
            var urlAppend = "";
            if (
              $rootScope.userInfo.photo_url.indexOf("?") ==
              $rootScope.userInfo.photo_url.length
            ) {
              urlAppend = new Date().getTime();
            } else {
              urlAppend = "?v=" + new Date().getTime();
            }
            $rootScope.userInfo.photo_url =
              $rootScope.userInfo.photo_url + urlAppend;
          },
        });
        //极光推送
        var info = {};
        var account = $rootScope.user.account;
        var uuid = cordovaService.getDeviceInfo().UUID;
        var platform = cordovaService.getDeviceInfo().platform;
        var systemVersion = cordovaService.getDeviceInfo().version;
        var deviceType = cordovaService.getDeviceInfo().model;
        var tags = [$rootScope.user.gender, $rootScope.user.cardType];
        var toJsonTags = angular.toJson(tags);
        //极光推送
        window.plugins.jPushPlugin.init();
        window.plugins.jPushPlugin.setDebugMode(true);
        window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0); //控制角标
        $rootScope.sequence = $rootScope.user.account;
        var tagParams = {
          sequence: $rootScope.sequence,
          tags: [$rootScope.user.gender, $rootScope.user.cardType],
        };
        window.plugins.jPushPlugin.setTags(
          tagParams,
          function (id) {
            console.log(id);
          },
          function (id) {
            console.log(id);
          }
        );

        if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
          var uuid2 = uuid.replace(/-/g, "").slice(-20);
        } else {
          var uuid2 = uuid;
        }
        var params = {
          sequence: $rootScope.sequence,
          alias: $rootScope.user.account + "_" + uuid2,
        };
        window.plugins.jPushPlugin.setAlias(
          params,
          function (data) {
            console.log(data);
          },
          function (data) {
            console.log(data);
          }
        );
        var registrationId;
        window.plugins.jPushPlugin.getRegistrationID(function (id) {
          try {
            console.log("JPushPlugin:registrationID is " + id);
            registrationId = id;
            if (id.length == 0) {
              var t1 = window.setTimeout(getRegistrationID, 1000);
            }
          } catch (exception) {
            console.log(exception);
          }
        });
        ngCordovaService.getAppVersionNumber({
          onSuccess: function (data, status, config, headers) {
            var appVersion = data;
            info = {
              account: account,
              uuid: uuid,
              imei: "",
              deviceType: deviceType,
              platform: platform,
              registrationId: registrationId,
              systemVersion: systemVersion,
              appVersion: appVersion,
              tags: toJsonTags,
            };
            //上传设备信息
            apiService.deviceInfo(info, {
              onSuccess: function (data, status, config, headers) {
                console.log(data);
              },
              onError: function (data, status, config, headers) {
                console.log(data);
              },
            });
          },
          onError: function (data, status, config, headers) {},
        });
        // window.plugins.jPushPlugin.init();
        // $rootScope.sequence = $rootScope.user.account;
        // window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0)//控制角标
        //接收消息并跳转相应的页面
        if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
          document.addEventListener(
            "jpush.openNotification",
            function (data) {
              var currentViewName = $ionicHistory.currentView().stateName;
              var obj = angular.fromJson(data);
              var msg = obj.aps.alert;
              var type = "LOANBOOK";
              if (
                currentViewName == "tab.bookhome" ||
                currentViewName == "tab.bookhomesetting" ||
                currentViewName == "tab.bhbookdetail" ||
                currentViewName == "tab.bhHomeBooks" ||
                currentViewName == "tab.bookhomemessage" ||
                currentViewName == "tab.bookhomeorder_return_detai" ||
                currentViewName == "tab.bookhomeorderreturn" ||
                currentViewName == "tab.bookhomemyorder" ||
                currentViewName == "tab.bookhomeorder_detail" ||
                currentViewName == "tab.bookhomepayconfirm"
              ) {
                $state.go("tab.bookhomemessage", { msg: msg, type: type });
              } else if (
                currentViewName == "tab.discovery" ||
                currentViewName == "tab.dcbhdetail" ||
                currentViewName == "tab.dcbookdetaildrift" ||
                currentViewName == "tab.dcHomeBooks" ||
                currentViewName == "tab.dcHomeBookLeaveMessage" ||
                currentViewName == "tab.bhorderconfirm" ||
                currentViewName == "tab.discoverymessage" ||
                currentViewName == "tab.discoveryorder_return_detai" ||
                currentViewName == "tab.discoveryorderreturn" ||
                currentViewName == "tab.discoverymyorder" ||
                currentViewName == "tab.discoveryorder_detail" ||
                currentViewName == "tab.discoverypayconfirm"
              ) {
                $state.go("tab.discoverymessage", { msg: msg, type: type });
              } else if (
                currentViewName == "tab.home" ||
                currentViewName == "tab.homeminereserve" ||
                currentViewName == "tab.homeorderconfirm" ||
                currentViewName == "tab.newbook-more" ||
                currentViewName == "tab.goodbook-more" ||
                currentViewName == "tab.searchBook" ||
                currentViewName == "tab.conditinalSearchBook" ||
                currentViewName == "tab.book-detail" ||
                currentViewName == "tab.top-loaned-books" ||
                currentViewName == "tab.category" ||
                currentViewName == "tab.myborrowed" ||
                currentViewName == "tab.homeorderreturn" ||
                currentViewName == "tab.historyLoanedBookDetail" ||
                currentViewName == "tab.homeorder_return_detail" ||
                currentViewName == "tab.activityworldmine" ||
                currentViewName == "tab.activitydetail" ||
                currentViewName == "tab.activityCreate" ||
                currentViewName == "tab.activityPatch" ||
                currentViewName == "tab.payconfirm" ||
                currentViewName == "returnbook" ||
                currentViewName == "tab.message" ||
                currentViewName == "tab.homemyorder" ||
                currentViewName == "tab.homeorder_detail" ||
                currentViewName == "tab.payconfirm" ||
                currentViewName == "tab.homemine_check_messages" ||
                currentViewName == "tab.homescanResult"
              ) {
                $state.go("tab.message", { msg: msg, type: type });
              } else {
                $state.go("tab.minemessage", { msg: msg, type: type });
              }
            },
            false
          );
        } else {
          window.plugins.jPushPlugin.openNotificationInAndroidCallback = function (
            data
          ) {
            var currentViewName = $ionicHistory.currentView().stateName;
            var obj = angular.fromJson(data);
            var msg = obj.extras["cn.jpush.android.ALERT"];
            var type = obj.extras.messageType;
            if (
              currentViewName == "tab.bookhome" ||
              currentViewName == "tab.bookhomesetting" ||
              currentViewName == "tab.bhbookdetail" ||
              currentViewName == "tab.bhHomeBooks" ||
              currentViewName == "tab.bookhomemessage" ||
              currentViewName == "tab.bookhomeorder_return_detai" ||
              currentViewName == "tab.bookhomeorderreturn" ||
              currentViewName == "tab.bookhomemyorder" ||
              currentViewName == "tab.bookhomeorder_detail" ||
              currentViewName == "tab.bookhomepayconfirm"
            ) {
              $state.go("tab.bookhomemessage", { msg: msg, type: type });
            } else if (
              currentViewName == "tab.discovery" ||
              currentViewName == "tab.dcbhdetail" ||
              currentViewName == "tab.dcbookdetaildrift" ||
              currentViewName == "tab.dcHomeBooks" ||
              currentViewName == "tab.dcHomeBookLeaveMessage" ||
              currentViewName == "tab.bhorderconfirm" ||
              currentViewName == "tab.discoverymessage" ||
              currentViewName == "tab.discoveryorder_return_detai" ||
              currentViewName == "tab.discoveryorderreturn" ||
              currentViewName == "tab.discoverymyorder" ||
              currentViewName == "tab.discoveryorder_detail" ||
              currentViewName == "tab.discoverypayconfirm"
            ) {
              $state.go("tab.discoverymessage", { msg: msg, type: type });
            } else if (
              currentViewName == "tab.home" ||
              currentViewName == "tab.homeminereserve" ||
              currentViewName == "tab.homeorderconfirm" ||
              currentViewName == "tab.newbook-more" ||
              currentViewName == "tab.goodbook-more" ||
              currentViewName == "tab.searchBook" ||
              currentViewName == "tab.conditinalSearchBook" ||
              currentViewName == "tab.book-detail" ||
              currentViewName == "tab.top-loaned-books" ||
              currentViewName == "tab.category" ||
              currentViewName == "tab.myborrowed" ||
              currentViewName == "tab.homeorderreturn" ||
              currentViewName == "tab.historyLoanedBookDetail" ||
              currentViewName == "tab.homeorder_return_detail" ||
              currentViewName == "tab.activityworldmine" ||
              currentViewName == "tab.activitydetail" ||
              currentViewName == "tab.activityCreate" ||
              currentViewName == "tab.activityPatch" ||
              currentViewName == "tab.payconfirm" ||
              currentViewName == "returnbook" ||
              currentViewName == "tab.message" ||
              currentViewName == "tab.homemyorder" ||
              currentViewName == "tab.homeorder_detail" ||
              currentViewName == "tab.payconfirm" ||
              currentViewName == "tab.homemine_check_messages" ||
              currentViewName == "tab.homescanResult"
            ) {
              $state.go("tab.message", { msg: msg, type: type });
            } else {
              $state.go("tab.minemessage", { msg: msg, type: type });
            }
          };
        }
        //查看用户的借书数量
        apiService.checkAllOrder($rootScope.user.borrowID, {
          onSuccess: function (data, status, config, headers) {
            var amountCount = 0;
            if (data) {
              if (data.packing) {
                amountCount += parseInt(data.packing);
              }
              if (data.paying) {
                amountCount += parseInt(data.paying);
              }
              if (data.delivering) {
                amountCount += parseInt(data.delivering);
              }
              if (data.receiving) {
                amountCount += parseInt(data.receiving);
              }
              if (data.picking) {
                amountCount += parseInt(data.picking);
              }
              $rootScope.myOrderCount = amountCount;
              if ($rootScope.myOrderCount == 0) {
                $rootScope.numberShow = false;
              } else {
                $rootScope.numberShow = true;
              }
            }
          },
        });
        //查看用户还书订单数量
        apiService.checkReturnOrders($rootScope.user.borrowID, {
          onSuccess: function (data, status, config, headers) {
            if (data) {
              var amountCount = 0;
              if (data.returning) {
                amountCount += parseInt(data.returning);
              }
              $rootScope.myReturnOrder = amountCount;
              if ($rootScope.myReturnOrder == 0) {
                $rootScope.returnNumberShow = false;
              } else {
                $rootScope.returnNumberShow = true;
              }
            }
          },
        });
        // 首页滚动图片
        apiService.getHomePageSlideImages({
          onSuccess: function (data, status, config, headers) {
            if (!_.isEmpty(data)) {
              try {
                if (!_.isEmpty(data.data) > 0) {
                  var imageUrls = [];
                  for (var index = 0; index < data.data.length; index++) {
                    var url = data.data[index].smallImageUrl; // imageUrl/smallImageUrl
                    imageUrls.push(url);
                  }
                  if (!_.isEmpty(imageUrls)) {
                    $rootScope.homePageSlideImageUrls = [];
                    var value = "";
                    for (var index = 0; index < imageUrls.length; index++) {
                      var url = imageUrls[index];
                      $rootScope.homePageSlideImageUrls.push(url);
                      value += url;
                      if (index < imageUrls.length - 1) {
                        value += ","; // 以“,”分割
                      }
                    }
                    // 4. 在localStorage中设置
                    localStorage.setItem("homePageSlideImageUrls", value);
                    console.log(
                      "从服务器获取首页滚动图片：\n" +
                        angular.toJson($rootScope.homePageSlideImageUrls)
                    );
                  } else {
                    console.warn("从服务器获取首页滚动图片：为空");
                  }
                }
              } catch (error) {
                console.error(
                  "从服务器获取首页滚动图片：出现异常，" + angular.toJson(error)
                );
              }
            }
          },
          onError: function (data, status, config, headers) {
            console.error("从服务器获取首页滚动图片：失败");
          },
          onFinally: function () {
            //
          },
        });
        // check newest app version

        $rootScope.refreshTokenTimer = setInterval(function () {
          if (localStorage.getItem("refresh_token")) {
            $http({
              method: "post",
              url: apiConstants.bookInteraction.user.refresh,
              headers: {
                Authorization: localStorage.getItem("refresh_token"),
              },
            })
              .success(function (res, status, headers, config) {
                window.localStorage.setItem(
                  "access_token",
                  headers("access-token")
                );
                window.localStorage.setItem(
                  "refresh_token",
                  headers("refresh-token")
                );
              })
              .error(function (msg) {
                if ($rootScope.refreshTokenTimer) {
                  clearInterval($rootScope.refreshTokenTimer);
                }
                $rootScope.user = null;
                localStorage.removeItem("loginInfo_password");
                localStorage.removeItem("reader_info");
                localStorage.removeItem("access_token");
                localStorage.removeItem("refresh_token");
                // 清除用户信息
                $rootScope.userInfo = null;
                $state.go("tab.mine");
              });
          }
        }, 60000);
      }
      if (ionic.Platform.isAndroid()) {
        // IOS 不允许有升级按钮或者提示

        var permissions = cordova.plugins.permissions;
        permissions.hasPermission(
          permissions.WRITE_EXTERNAL_STORAGE,
          checkPermissionCallback,
          null
        );
        function checkPermissionCallback(status) {
          if (!status.hasPermission) {
            var errorCallback = function () {
              // ionic.Platform.exitApp();
              return;
            };
            permissions.requestPermission(
              permissions.WRITE_EXTERNAL_STORAGE,
              function (status) {
                if (!status.hasPermission) errorCallback();
                document.addEventListener(
                  "deviceready",
                  function () {
                    console.log(
                      "deviceready. check the newest app version ..."
                    );
                    if (!appService.getCheckedAppInfo().versionCode) {
                      appService.checkAppInfo();
                    }
                    if (!appService.getNewestAppVersion().versionCode) {
                      appService.retrieveNewestAppVersion(true, true);
                    }
                  },
                  false
                );
              },
              errorCallback
            );
          } else {
            if (!appService.getCheckedAppInfo().versionCode) {
              appService.checkAppInfo();
            }
            if (!appService.getNewestAppVersion().versionCode) {
              appService.retrieveNewestAppVersion(true, true);
            }
          }
        }
      }
    });
  })

  .directive("scrollHeight", function ($window) {
    return {
      restrict: "AE",
      link: function (scope, element, attr) {
        element[0].style.height = $window.innerHeight - 44 - 49 - 35 + "px";
      },
    };
  })

  .config(function (
    $stateProvider,
    $urlRouterProvider,
    $ionicConfigProvider,
    $sceDelegateProvider
  ) {
    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    // set the tabs position
    //joshua
    $ionicConfigProvider.views.swipeBackEnabled(false);
    $ionicConfigProvider.views.transition("ios");
    $ionicConfigProvider.platform.android.tabs.position("standard");
    // $ionicConfigProvider.platform.android.navBar.alignTitle('center');
    $ionicConfigProvider.navBar
      .alignTitle("center")
      .positionPrimaryButtons("right");
    $ionicConfigProvider.scrolling.jsScrolling(true);
    //hide back text
    $ionicConfigProvider.backButton.previousTitleText(false);
    $ionicConfigProvider.backButton.text("返回");

    $sceDelegateProvider.resourceUrlWhitelist([
      // Allow same origin resource loads.
      "self",
      // Allow loading from our assets domain.  Notice the difference between * and **.
      "http://**",
    ]);

    $stateProvider

      // setup an abstract state for the tabs directive
      .state("tab", {
        url: "/tab",
        abstract: true,
        templateUrl: "modules/tabs.html",
      })

      // *******************************************
      // 图片上传
      .state("tab.image_uploader", {
        url: "/image_uploader",
        views: {
          "tab-mine": {
            templateUrl: "modules/image_uploader/imageUploader.html",
            controller: "ImageUploaderCtrl",
          },
        },
        cache: false,
      })

      /*
       * ****************************************************************
       * *******************           Home           *******************
       * ****************************************************************
       */

      // Each tab has its own nav history stack:
      // home页
      .state("tab.home", {
        url: "/home",
        views: {
          "tab-home": {
            templateUrl: "modules/home/tab-home.html",
            controller: "HomeCtrl",
          },
        },
        cache: false,
      })
      //极光推送的页面
      .state("tab.message", {
        url: "/message",
        views: {
          "tab-home": {
            templateUrl: "modules/home/message.html",
            controller: "MessageCtrl",
          },
        },
        cache: true,
        params: {
          msg: null,
          type: null,
        },
      })
      //极光推送的bookhome页面
      .state("tab.bookhomemessage", {
        url: "/bookhomemessage",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/home/message.html",
            controller: "MessageCtrl",
          },
        },
        cache: true,
        params: {
          msg: null,
          type: null,
        },
      })
      //极光推送的bookhome页面
      .state("tab.discoverymessage", {
        url: "/discoverymessage",
        views: {
          "tab-discovery": {
            templateUrl: "modules/home/message.html",
            controller: "MessageCtrl",
          },
        },
        cache: true,
        params: {
          msg: null,
          type: null,
        },
      })
      //极光推送的mine页面
      .state("tab.minemessage", {
        url: "/minemessage",
        views: {
          "tab-mine": {
            templateUrl: "modules/home/message.html",
            controller: "MessageCtrl",
          },
        },
        cache: true,
        params: {
          msg: null,
          type: null,
        },
      })

      // 新书列表
      .state("tab.newbook-more", {
        url: "/newbook-more",
        views: {
          "tab-home": {
            templateUrl: "modules/home/newbook-more.html",
            controller: "NewBookMoreCtrl",
          },
        },
        cache: true,
        params: {
          firstPageNewBooks: null,
        },
      })

      // 好书列表
      .state("tab.goodbook-more", {
        url: "/goodbook-more",
        views: {
          "tab-home": {
            templateUrl: "modules/home/goodbook-more.html",
            controller: "GoodBookMoreCtrl",
          },
        },
        params: {
          firstPageGoodBooks: null,
        },
        cache: true,
      })

      // 搜索
      .state("tab.searchBook", {
        url: "/searchBook",
        views: {
          "tab-home": {
            templateUrl: "modules/home/search-books.html",
            controller: "SearchBookCtrl",
          },
        },
        cache: true,
        params: {
          category: null,
        },
      })

      // 条件搜索 Conditional search
      .state("tab.conditinalSearchBook", {
        url: "/conditinalSearchBook",
        views: {
          "tab-home": {
            templateUrl: "modules/home/conditinal_search_book.html",
            controller: "ConditionalSearchBookCtrl",
          },
        },
        cache: true,
        params: {
          clc: null,
          wrd: null,
        },
      })

      // 图书详情
      .state("tab.book-detail", {
        url: "/book-detail",
        views: {
          "tab-home": {
            templateUrl: "modules/home/book-detail.html",
            controller: "BookDetailCtrl",
          },
        },
        cache: true,
        params: { book: null },
      })

      // 借阅排行榜列表
      .state("tab.top-loaned-books", {
        url: "/top-loaned-books",
        views: {
          "tab-home": {
            templateUrl: "modules/borrowbook/top-loaned-books.html",
            controller: "TopLoanedBooksCtrl",
          },
        },
        cache: true,
      })

      // 图书分类
      .state("tab.category", {
        url: "/category",
        views: {
          "tab-home": {
            templateUrl: "modules/home/tab-category.html",
            controller: "CategoryCtrl",
          },
        },
        cache: true,
      })

      /*
       * ****************************************************************
       * *******************  图书预、借、续、还等操作  *******************
       * ****************************************************************
       */
      // 图书预约
      .state("tab.myReserved", {
        url: "/myReserved",
        views: {
          "tab-home": {
            templateUrl: "modules/reservebook/myReserved.html",
            controller: "MyReservedCtrl",
          },
        },
        cache: true, //wsc-changed
      })

      // 预约的图书详情
      .state("tab.reservedBookDetail", {
        url: "/reservedBookDetail",
        views: {
          "tab-home": {
            templateUrl: "modules/reservebook/reserved_book_detail.html",
            controller: "reservedBookDetailCtrl",
          },
        },
        cache: false,
        params: {
          reservedBook: null,
        },
      })

      // 我的借阅
      .state("tab.myborrowed", {
        url: "/myborrowed",
        views: {
          "tab-home": {
            templateUrl: "modules/borrowbook/myborrowed.html",
            controller: "MyBorrowCtrl",
          },
        },
        cache: true, //wsc-change
      })

      // 图书归还 (单本图书)
      .state("returnbook", {
        url: "/returnbook",
        templateUrl: "modules/borrowbook/return_book.html",
        controller: "ReturnBookCtrl",
        params: {
          borCodes: null,
        },
        cache: false,
      })

      // 已借阅的图书详情
      .state("tab.loanedBookDetail", {
        url: "/loanedBookDetail",
        views: {
          "tab-home": {
            templateUrl: "modules/borrowbook/loaned_book_detail.html",
            controller: "OrderReturnCtrl",
          },
        },
        cache: false,
        params: {
          loanedBook: null,
        },
      })
      // 历史借阅的图书详情
      .state("tab.historyLoanedBookDetail", {
        url: "/historyLoanedBookDetail",
        views: {
          "tab-home": {
            templateUrl: "modules/borrowbook/history_loaned_book_detail.html",
            controller: "historyLoanedBookDetailCtrl",
          },
        },
        cache: false,
        params: {
          historyLoanedBook: null,
        },
      })

      // 订单确认
      .state("tab.orderconfirm", {
        url: "/orderconfirm",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/order_confirm.html",
            controller: "OrderConfirmCtrl",
          },
        },
        params: {
          book: null,
          groupBookIdsJson: null,
          bookIdJson: null,
        },
      })
      // 从home页面跳转到订单确认
      .state("tab.homeorderconfirm", {
        url: "/homeorderconfirm",
        views: {
          "tab-home": {
            templateUrl: "modules/order/order_confirm.html",
            controller: "OrderConfirmCtrl",
          },
        },
        params: {
          book: null,
          groupBookIdsJson: null,
          bookIdJson: null,
        },
      })
      //选择收货地址
      .state("tab.selectaddress", {
        url: "/selectaddress",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/selectAddress.html",
            controller: "SelectAddressCtrl",
          },
        },
        cache: false,
      })

      // 我的订单
      .state("tab.myorder", {
        url: "/myorder?to",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/my_order.html",
            controller: "MyOrderCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // home页面跳转我的订单
      .state("tab.homemyorder", {
        url: "/homemyorder?to",
        views: {
          "tab-home": {
            templateUrl: "modules/order/my_order.html",
            controller: "MyOrderCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // discovery页面跳转我的订单
      .state("tab.discoverymyorder", {
        url: "/discoverymyorder?to",
        views: {
          "tab-discovery": {
            templateUrl: "modules/order/my_order.html",
            controller: "MyOrderCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // bookhome页面跳转我的订单
      .state("tab.bookhomemyorder", {
        url: "/bookhomemyorder?to",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/order/my_order.html",
            controller: "MyOrderCtrl",
          },
        },
        cache: true, //wsc-change
      })
      //我的归还订单
      .state("tab.orderreturn", {
        url: "/orderreturn?to",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/order_return.html",
            controller: "OrderReturnCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // 从home页面跳转到归还图书订单列表
      .state("tab.homeorderreturn", {
        url: "/homeorderreturn?to",
        views: {
          "tab-home": {
            templateUrl: "modules/order/order_return.html",
            controller: "OrderReturnCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // 从bookhome页面跳转到归还图书订单列表
      .state("tab.bookhomeorderreturn", {
        url: "/bookhomeorderreturn?to",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/order/order_return.html",
            controller: "OrderReturnCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // 从discovery页面跳转到归还图书订单列表
      .state("tab.discoveryorderreturn", {
        url: "/discoveryorderreturn?to",
        views: {
          "tab-discovery": {
            templateUrl: "modules/order/order_return.html",
            controller: "OrderReturnCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // 订单详情
      .state("tab.order_detail", {
        url: "/order_detail",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/order_detail.html",
            controller: "OrderDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })

      // home订单详情
      .state("tab.homeorder_detail", {
        url: "/homeorder_detail",
        views: {
          "tab-home": {
            templateUrl: "modules/order/order_detail.html",
            controller: "OrderDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })

      // discovery订单详情
      .state("tab.discoveryorder_detail", {
        url: "/discoveryorder_detail",
        views: {
          "tab-discovery": {
            templateUrl: "modules/order/order_detail.html",
            controller: "OrderDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })

      // bookhome订单详情
      .state("tab.bookhomeorder_detail", {
        url: "/bookhomeorder_detail",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/order/order_detail.html",
            controller: "OrderDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })
      // 还书订单详情
      .state("tab.order_return_detail", {
        url: "/order_return_detail",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/order_return_detail.html",
            controller: "OrderReturnDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })
      // home页面还书订单详情
      .state("tab.homeorder_return_detail", {
        url: "/homeorder_return_detail",
        views: {
          "tab-home": {
            templateUrl: "modules/order/order_return_detail.html",
            controller: "OrderReturnDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })
      // discovery还书订单详情
      .state("tab.discoveryorder_return_detail", {
        url: "/discoveryorder_return_detail",
        views: {
          "tab-discovery": {
            templateUrl: "modules/order/order_return_detail.html",
            controller: "OrderReturnDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })
      // bookhome还书订单详情
      .state("tab.bookhomeorder_return_detail", {
        url: "/bookhomeorder_return_detail",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/order/order_return_detail.html",
            controller: "OrderReturnDetailCtrl",
          },
        },
        cache: false,
        params: {
          order: null,
        },
      })

      /*
       * ****************************************************************
       * *******************        你选书我买单       *******************
       * ****************************************************************
       */
      // 你选书我买单
      .state("tab.youchooseipay", {
        url: "/youchooseipay",
        views: {
          "tab-home": {
            templateUrl: "modules/youchooseipay/youchoose_ipay.html",
            controller: "YouchooseIpayCtrl",
          },
        },
        cache: true, //wsc-change
      })

      //你选书我买单我选择的图书详情
      .state("tab.youchooseipay_ic_book_detail", {
        url: "/youchooseipay_ic_book_detail",
        views: {
          "tab-home": {
            templateUrl: "modules/youchooseipay/ycip_ic_book_detail.html",
            controller: "YouchooseIpayIcBookDetailCtrl",
          },
        },
        params: {
          book: null,
          recommendedId: null,
          storeBook: null,
        },
        cache: false,
      })

      // 合约书店图书
      .state("tab.youchooseipay_books_in_store", {
        url: "/youchooseipay_books_in_store",
        views: {
          "tab-home": {
            templateUrl: "modules/youchooseipay/ycip_books_in_store.html",
            controller: "YouchooseIpayBooksInStoreCtrl",
          },
        },
        cache: true,
        params: {
          bookStore: null,
        },
      })

      /*
       * ****************************************************************
       * *******************           活动           *******************
       * ****************************************************************
       */
      // 我的活动
      .state("tab.activityworldmine", {
        url: "/activityworldmine",
        views: {
          "tab-home": {
            templateUrl: "modules/activity/activity_world_mine.html",
            controller: "ActivityWorldMineCtrl",
          },
        },
        cache: true, //wsc-change
      })
      // 活动详情
      .state("tab.activitydetail", {
        url: "/activitydetail",
        views: {
          "tab-home": {
            templateUrl: "modules/activity/activity_detail.html",
            controller: "activityDetailCtrl",
          },
        },
        cache: true,
        params: {
          activity: null,
        },
      })
      // 创建活动
      .state("tab.activityCreate", {
        url: "/activityCreate",
        views: {
          "tab-home": {
            templateUrl: "modules/activity/activity_create.html",
            controller: "createActivityCtrl",
          },
        },
        cache: false,
      })
      // 更新活动
      .state("tab.activityPatch", {
        url: "/activityPatch",
        views: {
          "tab-home": {
            templateUrl: "modules/activity/activity_patch.html",
            controller: "patchActivityCtrl",
          },
        },
        cache: false,
        params: {
          id: null,
          activity: null,
        },
      })

      /*
       * ****************************************************************
       * *******************           支付           *******************
       * ****************************************************************
       */
      // mine支付
      .state("tab.minepayconfirm", {
        url: "/minepayconfirm",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/pay_confirm.html",
            controller: "PayConfirmCtrl",
          },
        },
        params: {
          order: null,
          cardInfo: null,
        },
      })

      //home 支付
      .state("tab.payconfirm", {
        url: "/payconfirm",
        views: {
          "tab-home": {
            templateUrl: "modules/order/pay_confirm.html",
            controller: "PayConfirmCtrl",
          },
        },
        params: {
          order: null,
        },
      })
      //discovery 支付
      .state("tab.discoverypayconfirm", {
        url: "/discoverypayconfirm",
        views: {
          "tab-discovery": {
            templateUrl: "modules/order/pay_confirm.html",
            controller: "PayConfirmCtrl",
          },
        },
        params: {
          order: null,
        },
      })
      //bookhome 支付
      .state("tab.bookhomepayconfirm", {
        url: "/bookhomepayconfirm",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/order/pay_confirm.html",
            controller: "PayConfirmCtrl",
          },
        },
        params: {
          order: null,
        },
      })

      /*
       * ****************************************************************
       * *******************           书房           *******************
       * ****************************************************************
       */
      // 书房
      .state("tab.bookhome", {
        url: "/bookhome",
        cache: false,
        views: {
          "tab-bookhome": {
            templateUrl: "modules/bookhome/tab-bookhome.html",
            controller: "BookhomeCtrl",
          },
        },
      })
      // 书房设置
      .state("tab.bookhomesetting", {
        url: "/bookhomesetting",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/bookhome/bh_setting.html",
            controller: "BookhomeSettingCtrl",
          },
        },
        cache: false,
        params: {
          libraryRoomInfo: null,
        },
      })
      // 书房图书详情
      .state("tab.bhbookdetail", {
        url: "/bhbookdetail",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/bookhome/bh_bookdetail.html",
            controller: "BookHomeBookDetailCtrl",
          },
        },
        cache: false,
        params: {
          book: null,
        },
      })
      // 书房藏书列表
      .state("tab.bhHomeBooks", {
        url: "/bhHomeBooks",
        views: {
          "tab-bookhome": {
            templateUrl: "modules/bookhome/bh_home_books.html",
            controller: "BookHomeBooksCtrl",
          },
        },
        cache: true,
        params: {
          user_id: null,
          loanable: null,
        },
      })
      /*
       * ****************************************************************
       * *******************       发现/漂流           *******************
       * ****************************************************************
       */
      // 发现
      .state("tab.discovery", {
        url: "/discovery",
        cache: false,
        views: {
          "tab-discovery": {
            templateUrl: "modules/discovery/tab-discovery.html",
            controller: "DiscoveryCtrl",
          },
        },
      })
      // （其他）人书房详情
      .state("tab.dcbhdetail", {
        url: "/dcbhdetail",
        views: {
          "tab-discovery": {
            templateUrl: "modules/discovery/dc_bhdetail.html",
            controller: "discoveryBookhomeCtrl",
          },
        },
        cache: false,
        params: {
          person: null,
        },
      })
      // （漂流）书房图书详情
      .state("tab.dcbookdetaildrift", {
        url: "/dcbookdetaildrift",
        views: {
          "tab-discovery": {
            templateUrl: "modules/discovery/dc_bookdetaildrift.html",
            controller: "DiscoveryBookHomeBookDetailCtrl",
          },
        },
        params: {
          book: null,
        },
      })
      // （漂流）书房藏书列表
      .state("tab.dcHomeBooks", {
        url: "/dcHomeBooks",
        views: {
          "tab-discovery": {
            templateUrl: "modules/discovery/dc_home_books.html",
            controller: "DiscoveryBookHomeBooksCtrl",
          },
        },
        cache: true,
        params: {
          person: null,
          loanable: null,
        },
      })
      // （漂流）书房图书 留言
      .state("tab.dcHomeBookLeaveMessage", {
        url: "/dcHomeBookLeaveMessage",
        views: {
          "tab-discovery": {
            templateUrl:
              "modules/discovery/dc_bookhome_book_leave_message.html",
            controller: "DiscoveryBookHomeBookLeaveMessageCtrl",
          },
        },
        cache: false,
        params: {
          book: null, // 这个book已经包含了书房和图书信息
        },
      })

      //漂流借阅定单
      .state("tab.bhorderconfirm", {
        url: "/bhorderconfirm",
        views: {
          "tab-discovery": {
            templateUrl: "modules/discovery/dc_bhorderconfirm.html",
            controller: "OrderConfirmCtrl",
          },
        },
      })

      /*
       * ****************************************************************
       * *******************           收藏           *******************
       * ****************************************************************
       */

      /*
       * ****************************************************************
       * *******************           我的           *******************
       * ****************************************************************
       */

      .state("tab.mine", {
        url: "/mine",
        cache: false,
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/tab-mine.html",
            controller: "MineCtrl",
          },
        },
        params: {
          fromState: null,
        },
      })

      // 粉丝
      .state("tab.mine_fans", {
        url: "/mine_fans",
        cache: true, //wsc-change
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_fans.html",
            controller: "FansCtrl",
          },
        },
        params: {
          fans: null,
        },
      })

      // 关注
      .state("tab.mine_follows", {
        url: "/mine_follow",
        cache: true, //wsc-change
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_follows.html",
            controller: "FollowCtrl",
          },
        },
      })

      // 消息
      .state("tab.mine_check_messages", {
        url: "/mine_check_messages",
        cache: false,
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_check_messages.html",
            controller: "MineCheckMessagesCtrl",
          },
        },
        params: {
          follows: null,
        },
      })
      // // home页面跳转到消息
      // .state('tab.homemine_check_messages', {
      //   url: '/homemine_check_messages',
      //   cache: false,
      //   views: {
      //     'tab-home': {
      //       templateUrl: 'modules/mine/mine_check_messages.html',
      //       controller: 'MineCheckMessagesCtrl'
      //     }
      //   },
      //   params: {
      //     follows: null
      //   }
      // })
      //收藏
      .state("tab.mine_favorites", {
        url: "/mine_favorites",
        cache: true, //wsc-change
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_favorites.html",
            controller: "MyFavoritesCtrl",
          },
        },
      })

      .state("tab.mine_favorite_detail", {
        url: "/mine_favorite_detail",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_favorite_detail.html",
            controller: "MyFavoriteDetailCtrl",
          },
        },
        params: { book: null },
        cache: false,
      })

      // 设置
      .state("tab.minesettings", {
        url: "/minesettings",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_settings.html",
            controller: "SettingsCtrl",
          },
        },
        cache: false,
      })
      //帮助反馈
      .state("tab.helpFeedback", {
        url: "/helpFeedback",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/helpFeedback.html",
            controller: "HelpFeedbackCtrl",
          },
        },
        cache: false,
      })
      //新手须知
      .state("tab.newerGuide", {
        url: "/newerGuide",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/newerGuide.html",
          },
        },
        cache: false,
      })
      //书房位置
      .state("tab.bookroomLocation", {
        url: "/bookroomLocation",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/bookroomLocation.html",
            controller: "BookroomLocationCtrl",
          },
        },
        cache: false,
      })

      //借阅流程
      .state("tab.borrowProcess", {
        url: "/borrowProcess",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/borrowProcess.html",
          },
        },
        cache: false,
      })
      //退卡须知
      .state("tab.returnCard", {
        url: "/returnCard",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/returnCard.html",
            controller: "ReturnCardCtrl",
          },
        },
        cache: false,
      })
      // 版本信息
      .state("tab.mine_version", {
        url: "/mine_version",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_version.html",
            controller: "VersionCtrl",
          },
        },
        cache: false,
      })

      // 版本历史
      .state("tab.mine_function", {
        url: "/mine_function",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_function.html",
            controller: "FunctionCtrl",
          },
        },
        cache: false,
      })
      //服务协议
      .state("tab.serviceAgreement", {
        url: "/serviceAgreement",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/serviceAgreement.html",
            controller: "ServiceAgreementCtrl",
          },
        },
        cache: false,
      })
      //
      .state("tab.homeserviceAgreement", {
        url: "/homeserviceAgreement",
        views: {
          "tab-home": {
            templateUrl: "modules/mine/serviceAgreement.html",
            controller: "ServiceAgreementCtrl",
          },
        },
        cache: false,
      })
      //隐私政策
      .state("tab.privacyPolicy", {
        url: "/privacyPolicy",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/privacyPolicy.html",
            controller: "PrivacyPolicyCtrl",
          },
        },
        cache: false,
      })
      //
      .state("tab.homeprivacyPolicy", {
        url: "/homeprivacyPolicy",
        views: {
          "tab-home": {
            templateUrl: "modules/mine/privacyPolicy.html",
            controller: "PrivacyPolicyCtrl",
          },
        },
        cache: false,
      })
      // 我的资料
      .state("tab.myinfo", {
        url: "/myinfo",
        params: { book: null },
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_myinfo.html",
            controller: "MyInfoCtrl",
          },
        },
      })

      // 修改密码
      .state("tab.mine_avator", {
        url: "/mine_avator",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_avator.html",
            controller: "MineAvatorCtrl",
          },
        },
        cache: false,
      })

      // 修改密码
      .state("tab.changepwd", {
        url: "/changepwd",
        params: { book: null },
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_changepwd.html",
            controller: "MineChangePwdCtrl",
          },
        },
      })

      // 修改手机号码
      .state("tab.changephonenum", {
        url: "/changephonenum",
        params: { book: null },
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_changephonenum.html",
            controller: null,
          },
        },
      })
      //用户收货地址
      .state("tab.mine_address", {
        url: "/mine_address",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_address.html",
            controller: "MineAddressCtrl",
          },
        },
        cache: false,
      })
      //新建用户地址
      .state("tab.addressAdd", {
        url: "/addressAdd",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/addressAdd.html",
            controller: "AddressAddCtrl",
          },
        },
        params: { address: null, title: null },
        cache: true,
      })
      // 常见问题
      .state("tab.normalquestion", {
        url: "/normalquestion",
        params: { book: null },
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_normalquestion.html",
            controller: "NormalQuestionCtrl",
          },
        },
        cache: true,
      })

      //联系我们
      .state("tab.onlinecomments", {
        url: "/onlinecomments",
        params: { book: null },
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_onlinecomments.html",
            controller: "OnlineCommentsCtrl",
          },
        },
      })

      // 我的->我的孩子
      .state("tab.mineChildren", {
        url: "/mineChildren",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_children.html",
            controller: "MineChildrenController",
          },
        },
      })
      //我的 ->选书篮
      .state("tab.bookCart", {
        url: "/bookCart",
        views: {
          "tab-mine": {
            templateUrl: "modules/order/book_cart.html",
            controller: "BookCartCtrl",
          },
        },
        cache: true,
      })
      //我的预约
      .state("tab.minereserve", {
        url: "/minereserve",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/mine_reserve.html",
            controller: "reserveCtrl",
          },
        },
        cache: true,
      })
      //home页面的预约
      .state("tab.homeminereserve", {
        url: "/homeminereserve",
        views: {
          "tab-home": {
            templateUrl: "modules/mine/mine_reserve.html",
            controller: "reserveCtrl",
          },
        },
        cache: true,
      })
      //我的->扫码开门
      .state("tab.scanResult", {
        url: "/scanResult",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/scanResult.html",
            controller: "ScanResultCtrl",
          },
        },
        cache: false,
        params: {
          scanResult: null,
        },
      })
      .state("tab.homescanResult", {
        url: "/homescanResult",
        views: {
          "tab-home": {
            templateUrl: "modules/mine/scanResult.html",
            controller: "ScanResultCtrl",
          },
        },
        cache: false,
        params: {
          scanResult: null,
        },
      })
      // 我的->我的借阅
      .state("tab.minemyborrowed", {
        url: "/minemyborrowed",
        views: {
          "tab-mine": {
            templateUrl: "modules/borrowbook/myborrowed.html",
            controller: "MyBorrowCtrl",
          },
        },
        cache: true,
      })

      // 我的->已借阅的图书详情
      .state("tab.mineloanedBookDetail", {
        url: "/mineloanedBookDetail",
        views: {
          "tab-mine": {
            templateUrl: "modules/borrowbook/loaned_book_detail.html",
            controller: "loanedBookDetailCtrl",
          },
        },
        cache: false,
        params: {
          loanedBook: null,
        },
      })
      // 我的->历史借阅的图书详情
      .state("tab.minehistoryLoanedBookDetail", {
        url: "/minehistoryLoanedBookDetail",
        views: {
          "tab-mine": {
            templateUrl: "modules/borrowbook/history_loaned_book_detail.html",
            controller: "historyLoanedBookDetailCtrl",
          },
        },
        cache: false,
        params: {
          historyLoanedBook: null,
        },
      })

      // 我的-> 你选书我买单
      .state("tab.mineyouchooseipay", {
        url: "/mineyouchooseipay",
        views: {
          "tab-mine": {
            templateUrl: "modules/youchooseipay/youchoose_ipay.html",
            controller: "YouchooseIpayCtrl",
          },
        },
        cache: true,
      })
      //我的->你选书我买单我选择的图书详情
      .state("tab.mineyouchooseipay_ic_book_detail", {
        url: "/mineyouchooseipay_ic_book_detail",
        views: {
          "tab-mine": {
            templateUrl: "modules/youchooseipay/ycip_ic_book_detail.html",
            controller: "YouchooseIpayIcBookDetailCtrl",
          },
        },
        params: {
          book: null,
        },
        cache: false,
      })

      // 我的->合约书店图书
      .state("tab.mineyouchooseipay_books_in_store", {
        url: "/mineyouchooseipay_books_in_store",
        views: {
          "tab-mine": {
            templateUrl: "modules/youchooseipay/ycip_books_in_store.html",
            controller: "YouchooseIpayBooksInStoreCtrl",
          },
        },
        cache: true,
        params: {
          bookStore: null,
        },
      })

      // 我的->（其他）人书房详情
      .state("tab.minedcbhdetail", {
        url: "/minedcbhdetail",
        views: {
          "tab-mine": {
            templateUrl: "modules/discovery/dc_bhdetail.html",
            controller: "discoveryBookhomeCtrl",
          },
        },
        cache: true,
        params: {
          person: null,
        },
      })
      // 我的->（漂流）书房藏书列表
      .state("tab.minedcHomeBooks", {
        url: "/dcHomeBooks",
        views: {
          "tab-mine": {
            templateUrl: "modules/discovery/dc_home_books.html",
            controller: "DiscoveryBookHomeBooksCtrl",
          },
        },
        cache: true,
        params: {
          person: null,
          loanable: null,
        },
      })
      // 我的->（漂流）书房图书详情
      .state("tab.minedcbookdetaildrift", {
        url: "/minedcbookdetaildrift",
        views: {
          "tab-mine": {
            templateUrl: "modules/discovery/dc_bookdetaildrift.html",
            controller: "DiscoveryBookHomeBookDetailCtrl",
          },
        },
        params: {
          book: null,
        },
      })
      // 我的->（漂流）书房图书 留言
      .state("tab.minedcHomeBookLeaveMessage", {
        url: "/minedcHomeBookLeaveMessage",
        views: {
          "tab-mine": {
            templateUrl:
              "modules/discovery/dc_bookhome_book_leave_message.html",
            controller: "DiscoveryBookHomeBookLeaveMessageCtrl",
          },
        },
        cache: false,
        params: {
          book: null, // 这个book已经包含了书房和图书信息
        },
      })

      //自主办证
      .state("tab.cardNote", {
        url: "/cardNote",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/cardNote.html",
            controller: "CardNoteCtrl",
          },
        },
        cache: true,
      })
      .state("tab.identityAuthentication", {
        url: "/identityAuthentication",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/identityAuthentication.html",
            controller: "IdentityAuthenticationCtrl",
          },
        },
        cache: true,
      })
      .state("tab.writeInfo", {
        url: "/writeInfo",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/writeInfo.html",
            controller: "WriteInfoCtrl",
          },
        },
        cache: true,
        params: {
          name: null,
          gender: null,
          id: null,
        },
      })
      .state("tab.unboundFace", {
        url: "/unboundFace",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/unboundFace.html",
            controller: "UnboundFaceCtrl",
          },
        },
        cache: true,
      })
      .state("depositPay", {
        url: "/depositPay",
        templateUrl: "modules/mine/depositPay.html",
        controller: "DepositPayCtrl",
        cache: true,
        params: {
          cash: null,
          cardName: null,
          cardNum: null,
          readerCardId: null,
        },
      })
      .state("registerPay", {
        url: "/registerPay",
        templateUrl: "modules/mine/registerPay.html",
        controller: "RegisterPayCtrl",
        cache: true,
        params: {
          order: null,
          cardInfo: null,
        },
      })
      .state("tab.uploadFace", {
        url: "/uploadFace",
        views: {
          "tab-mine": {
            templateUrl: "modules/mine/uploadFace.html",
            controller: "UploadFaceCtrl",
          },
        },

        cache: true,
      });
    //last one have ;

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise("/tab/home");
  });
