angular.module('starter.controllers')

    .controller('BookhomeCtrl', function ($scope, $state, $ionicHistory, $ionicPopup, $ionicLoading, $ionicActionSheet, $cordovaBarcodeScanner, $timeout, apiService, uiService, ngCordovaService, $ionicTabsDelegate, $ionicHistory, broadcastService, broadcastConstants) {
        // 由于该状态是从'tab.mine'跳过来的，再在app.js中通过$stateChangeStart处理，会出现问题。故手动处理如下。
        if (!$scope.user) {
            $state.go('tab.mine', { fromState: $ionicHistory.currentStateName() });
            return;
        }

        $ionicHistory.clearHistory();

        //
        $scope.libraryRoomInfo = null;
        $scope.allBooks = [];
        $scope.lineAllBooks = [];
        $scope.loanableBooks = [];
        $scope.lineLoanableBooks = [];
        var lineColsCapacity = 3;
        $scope.isAllBooksLoading = false;
        $scope.isLoanedBooksLoading = false;


        // -------------------------------------------------------------------------------------------------------------------
        $scope.getLibraryRoomShownName = function () {
            if ($scope.libraryRoomInfo && $scope.libraryRoomInfo.libraryName && $scope.libraryRoomInfo.libraryName.length > 0) {
                return $scope.libraryRoomInfo.libraryName;
                // } else if ($scope.user && $scope.user.name) {
                //     return $scope.user.name + '的书房';
            } else {
                return '我的书房';
            }
        }

        // -------------------------------------------------------------------------------------------------------------------
        // 查询用户书房信息
        $scope.queryLibraryRoomInfo = function () {
            uiService.ionicLoadingShow({ templateTitle: '正在查询书房信息...' });
            apiService.queryLibraryRoomInfo($scope.user.account, queryLibraryRoomInfoCallback);
        };
        var queryLibraryRoomInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.libraryRoomInfo = data;
                if (_.isEmpty($scope.libraryRoomInfo)) {
                    $ionicPopup.confirm(
                        {
                            title: '创建书房',
                            template: '您还没有创建书房，是否现在就创建？',
                            okText: '创建',
                            cancelText: '取消',
                        }
                    ).then(function (res) {
                        if (res) {
                            $scope.goBookHomeSetting();
                        } else {
                            $state.go('tab.home');
                        }
                    });
                } else {
                    $scope.retrieveAllBookFromUserLibraryRoom();
                    $scope.retrieveLoanableBookFromUserLibraryRoom();
                }
            },
            onError: function (data, status, config, headers) {
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };


        // -------------------------------------------------------------------------------------------------------------------
        // 新增一本书籍到书房
        $scope.hideSheet = undefined;
        $scope.addBookToLibraryRoom = function () {
            $scope.hideSheet = $ionicActionSheet.show({
                buttons: [
                    { text: '扫描图书ISBN条码' },
                    { text: '输入图书ISBN条码' }
                ],
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:
                            $cordovaBarcodeScanner.scan()
                                .then(
                                    function (result) {
                                        // alert("We got a barcode\n" +
                                        //     "Result: " + result.text + "\n" +
                                        //     "Format: " + result.format + "\n" +
                                        //     "Cancelled: " + result.cancelled);
                                        // $scope.isRetrieveDoubanBookInfo = true;
                                        uiService.ionicLoadingShow({ templateTitle: '正在查询您提交的图书信息...' });//wsc-change
                                        apiService.retrieveDoubanBookInfo(result.text, retrieveDoubanBookInfoCallback);
                                        // trace
                                        $scope.tmp = {};
                                        $scope.tmp.BookISBN = result.text;
                                    },
                                    function (error) {
                                        consolog.warn("Scanning failed: " + error);
                                        ngCordovaService.showToast('摄像头可能正在使用中，请稍后再试...');
                                    }
                                );
                            break;
                        case 1:
                            $scope.tmp = {};
                            $scope.tmp.BookISBN = null;
                            $ionicPopup.confirm(
                                {
                                    title: '手动输入图书ISBN信息',
                                    template: '<label class="item item-input"><span class="input-label">ISBN</span><input type="number" ng-model="tmp.BookISBN"/></label>',
                                    scope: $scope,
                                    cancelText: '取消',
                                    okText: '确定'
                                }
                            ).then(function (res) {
                                if (res) {
                                    // $scope.isRetrieveDoubanBookInfo = true;
                                    uiService.ionicLoadingShow({ templateTitle: '正在查询您提交的图书信息...' });//wsc-change 显示缓冲条
                                    apiService.retrieveDoubanBookInfo($scope.tmp.BookISBN, retrieveDoubanBookInfoCallback);
                                } else {
                                    $scope.tmp = undefined;
                                }
                            });
                            break;
                        default:
                            break;
                    };
                    //
                    if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
                        $timeout(function () {
                            //close the popup after 3 seconds for some reason
                            if ($scope.hideSheet) {
                                $scope.hideSheet();
                                $scope.hideSheet = undefined;
                            }
                        }, 500);
                        return false;
                    } else {
                        return true;
                    }
                }
            });
        };
        var retrieveDoubanBookInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                if (data) {
                    $scope.tmpDoubanBookInfo = data;
                    $scope.tmpBook = { userId: $scope.user.account, isbn: $scope.tmpDoubanBookInfo.isbn, count: 0 };
                    // TODO 遍历当前已有图书列表（假设当前已经获取了所有的图书）
                    var book = null;
                    if ($scope.allBooks) {
                        for (var i = 0; i < $scope.allBooks.length; i++) {
                            var libraryRoom = $scope.allBooks[i].libraryRoom;
                            if (libraryRoom.isbn == $scope.tmpBook.isbn) {
                                book = libraryRoom;
                                break;
                            }
                        }
                    }
                    // 找到已有图书，则提示，否则添加。
                    if (book) {
                        $ionicPopup.alert(
                            {
                                subTitle: '您之前已经收藏过该书。',
                                templateUrl: 'modules/bookhome/bh_repeated_book.html',
                                scope: $scope,
                                okText: '确定'
                            }
                        );
                    } else {
                        $ionicPopup.confirm(
                            {
                                title: '添加图书到书房',
                                templateUrl: 'modules/bookhome/bh_new_book.html',
                                scope: $scope,
                                cancelText: '取消',
                                okText: '确定'
                            }
                        ).then(function (res) {
                            if (res) {
                                uiService.ionicLoadingShow({ templateTitle: '正在添加图书...' });
                                apiService.addBookToLibraryRoom($scope.tmpBook, addBookToLibraryRoomCallback);
                            } else {
                                $scope.tmpDoubanBookInfo = null;
                            }
                        });
                    }
                } else {
                    var title = '';
                    if (!$scope.tmp || !$scope.tmp.BookISBN) {
                        title = '未找到与该ISBN匹配的书籍';
                    } else {
                        title = '未找到与该ISBN（' + $scope.tmp.BookISBN + '）匹配的书籍';
                    }
                    $ionicPopup.alert(
                        {
                            title: title,
                            okText: '确定'
                        }
                    );
                }
            },
            onError: function (data, status, config, headers) {
                var title = '';
                if (!$scope.tmp || !$scope.tmp.BookISBN) {
                    title = '未找到与该ISBN匹配的书籍';
                } else {
                    title = '未找到与该ISBN（' + $scope.tmp.BookISBN + '）匹配的书籍';
                }
                $ionicPopup.alert(
                    {
                        title: title,
                        okText: '确定'
                    }
                );
            },
            /******************************wsc-change*****************************/
            onFinally: function () {
                $ionicLoading.hide();
            }
        };
        var addBookToLibraryRoomCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.retrieveAllBookFromUserLibraryRoom();
                $scope.retrieveLoanableBookFromUserLibraryRoom();
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '添加失败',
                        okText: '确定',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                $ionicLoading.hide();
            }
        };




        // -------------------------------------------------------------------------------------------------------------------
        // 当前用户书房的所有图书
        $scope.retrieveAllBookFromUserLibraryRoom = function () {
            $scope.isAllBooksLoading = true;
            apiService.retrieveAllBooksFromUserLibraryRoom($scope.user.account, retrieveAllBookFromUserLibraryRoomCallback);
        };
        var retrieveAllBookFromUserLibraryRoomCallback = {
            onSuccess: function (data, status, config, headers) {
                // 初始化所有图书
                $scope.allBooks = data;
                if ($scope.allBooks) {
                    // 初始化当前页可显示的所有图书
                    $scope.lineAllBooks = [];
                    for (var i = 0; i < lineColsCapacity && i < $scope.allBooks.length; i++) {
                        $scope.lineAllBooks.push($scope.allBooks[i]);
                    }
                    // for (var i = $scope.lineAllBooks.length; i < lineColsCapacity; i++) {
                    //     $scope.lineAllBooks.push({});
                    // }
                }
            },
            onError: function (data, status, config, headers) {
                // do nothing
            },
            onFinally: function () {
                $scope.isAllBooksLoading = false;
            }
        };
        // 当前用户书房的所有可借图书
        $scope.retrieveLoanableBookFromUserLibraryRoom = function () {
            $scope.isLoanedBooksLoading = true;
            apiService.retrieveLoanableBooksFromUserLibraryRoom($scope.user.account, retrieveLoanableBookFromUserLibraryRoomCallback);
        };
        var retrieveLoanableBookFromUserLibraryRoomCallback = {
            onSuccess: function (data, status, config, headers) {
                // 初始化所有可借图书
                $scope.loanableBooks = data;
                // 初始化当前可显示的可借图书
                $scope.lineLoanableBooks = [];
                for (var i = 0; i < lineColsCapacity && i < $scope.loanableBooks.length; i++) {
                    $scope.lineLoanableBooks.push($scope.loanableBooks[i]);
                }
                // for (var i = $scope.lineLoanableBooks.length; i < lineColsCapacity; i++) {
                //     $scope.lineLoanableBooks.push({});
                // }
            },
            onError: function (data, status, config, headers) {
                // do nothing
            },
            onFinally: function () {
                $scope.isLoanedBooksLoading = false;
            }
        };



        // -------------------------------------------------------------------------------------------------------------------
        // 刷新数据
        function refreshBooks() {

        };



        // -------------------------------------------------------------------------------------------------------------------
        $scope.goBookDetail = function (book) {
            if (book) {
                $state.go('tab.bhbookdetail',
                    {
                        book: book
                    }
                );
            }
        };
        $scope.goHomeBooks = function (user_id, loanable) {
            $ionicHistory.clearCache().then(
                function () {
                    $state.go('tab.bhHomeBooks',
                        {
                            user_id: user_id,
                            loanable: loanable
                        }
                    );
                }
            );
        };
        $scope.goBookHomeSetting = function () {
            $state.go('tab.bookhomesetting',
                {
                    libraryRoomInfo: $scope.libraryRoomInfo,
                }
            );
        };




        // -------------------------------------------------------------------------------------------------------------------
        var onBookHomeBookChangedListener = function (data) {
            console.log('BookhomeCtrl', angular.toJson(data, true));
        };
        broadcastService.register(broadcastConstants.names.onBookHomeBookChanged, onBookHomeBookChangedListener);
        $scope.$on('$destroy', function () {
            broadcastService.unregister(broadcastConstants.names.onBookHomeBookChanged, onBookHomeBookChangedListener);
        });



        // -------------------------------------------------------------------------------------------------------------------
        //
        $scope.queryLibraryRoomInfo();
        $ionicTabsDelegate.showBar(true);
    });
