angular
  .module("starter.controllers")

  .controller("WriteInfoCtrl", function(
    $interval,
    $scope,
    $stateParams,
    $state,
    $ionicHistory,
    $ionicLoading,
    apiService,
    uiService,
    ngCordovaService,
    $ionicTabsDelegate
  ) {
    $scope.mainInfo = {
      telePhone: null,
      identifyCode: null,
      passWord: null,
      confirmPsd: null,
      selectValue: null
    };
    $scope.cardClasses = [];

    $scope.idCardInfo = {
      name: null,
      gender: null,
      id: null
    };
    if (ionic.Platform.isIPad() || ionic.Platform.isIOS()) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
    } else {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    $scope.idCardInfo.name = $stateParams.name;
    $scope.idCardInfo.id = $stateParams.id;
    $scope.idCardInfo.gender = $stateParams.gender;
    $scope.getcardClasses = function() {
      apiService.getCardInfo($scope.idCardInfo.id, {
        onSuccess: function(data, status, config, headers) {
          if (data.status == "OK") {
            $scope.cardClasses = data.data;
          } else {
            ngCordovaService.showToast(data.data);
          }
        },
        onError: function(data, status, config, headers) {
          ngCordovaService.showToast("服务器请求失败，请稍后再试");
        }
      });
    };
    $scope.getcardClasses();
    $scope.flag = false;
    $scope.getCode = function() {
      if (_.isEmpty($scope.mainInfo.selectValue)) {
        ngCordovaService.showToast("请选择读者卡级别");
        return;
      }
      if (
        $scope.mainInfo.telePhone &&
        /^0?(13|14|15|17|18)[0-9]{9}$/.test($scope.mainInfo.telePhone)
      ) {
        $scope.getSendCode($scope.mainInfo.telePhone);
      } else {
        ngCordovaService.showToast("请填写正确的手机号");
      }
    };
    // //发送验证码
    $scope.getSendCode = function(telephone) {
      apiService.getVcodeSending(
        telephone,
        {
          onSuccess: function(data, status, config, headers) {
            if (data.status == "OK") {
              ngCordovaService.showToast("验证码已发送，请等待");
              $scope.flag = true;
              $scope.codeTime = 180;
              var int = $interval(function() {
                $scope.codeTime--;
                if ($scope.codeTime == 0) {
                  $scope.flag = false;
                  $interval.cancel(int);
                }
              }, 1000);
            } else {
              ngCordovaService.showToast(data.data);
            }
          },
          onError: function(data, status, config, headers) {
            ngCordovaService.showToast("服务器请求失败，请稍后再试");
          }
        } //,  该处多添加了一个逗号，导致在魅族手机上运行时报错
      );
    };
    // //校验验证码
    $scope.checkCode = function(telephone, code, registerCard) {
      var registerData = registerCard;
      apiService.checkVcodeSending(telephone, code, {
        onSuccess: function(data, status, config, headers) {
          if (data.status == "OK") {
            uiService.ionicLoadingShow({ templateTitle: "正在注册电子证..." });
            apiService.registerCard(registerData, {
              onSuccess: function(data, status, config, headers) {
                if (data.status == "OK") {
                  ngCordovaService.showToast("上传资料成功");
                  var readerCardId = data.data.readerCardId;
                  var cardNum = data.data.orderId;
                  $ionicHistory.clearCache().then(function() {
                    $state.go("depositPay", {
                      cash: $scope.mainInfo.selectValue.cash,
                      cardName: $scope.mainInfo.selectValue.cardName,
                      cardNum: cardNum,
                      readerCardId: readerCardId
                    });
                  });
                } else {
                  ngCordovaService.showToast(data.data);
                }
              },
              onError: function(data, status, config, headers) {
                ngCordovaService.showToast("服务器请求失败，请稍后再试");
              },
              onFinally: function() {
                $ionicLoading.hide();
              }
            });
          } else {
            ngCordovaService.showToast(data.data);
            return;
          }
        },
        onError: function(data, status, config, headers) {
          ngCordovaService.showToast("服务器请求失败，请稍后再试");
          return;
        }
      });
    };
    $scope.goPayPage = function() {
      if (_.isEmpty($scope.mainInfo.selectValue)) {
        ngCordovaService.showToast("请选择读者卡级别");
        return;
      }
      if (!$scope.mainInfo.telePhone) {
        ngCordovaService.showToast("手机号码不能为空");
        return;
      }
      if (!/^0?(13|14|15|17|18)[0-9]{9}$/.test($scope.mainInfo.telePhone)) {
        ngCordovaService.showToast("手机号码格式错误，请重填");
        return;
      }
      if (!$scope.mainInfo.identifyCode) {
        ngCordovaService.showToast("请填写验证码");
        return;
      }
      if (!$scope.mainInfo.passWord) {
        ngCordovaService.showToast("请填写密码");
        return;
      }
      if (!/^\d{6}$/.test($scope.mainInfo.passWord)) {
        ngCordovaService.showToast("请填写六位数字密码");
        return;
      }
      if (!$scope.mainInfo.confirmPsd) {
        ngCordovaService.showToast("请再次确认密码");
        return;
      }
      if ($scope.mainInfo.confirmPsd != $scope.mainInfo.passWord) {
        ngCordovaService.showToast("两次输入密码不一致");
        return;
      }
      var registerCard = {
        idCardNum: $scope.idCardInfo.id,
        telephone: $scope.mainInfo.telePhone,
        password: $scope.mainInfo.passWord,
        cardType: $scope.mainInfo.selectValue.type
      };
      $scope.checkCode(
        $scope.mainInfo.telePhone,
        $scope.mainInfo.identifyCode,
        registerCard
      );
    };
    $ionicTabsDelegate.showBar(false);
  });
