angular.module('starter.controllers')

    .controller('BookCartCtrl', function ($rootScope, $scope, $state, $stateParams, $ionicTabsDelegate, $ionicModal, apiService, uiService, ngCordovaService, $ionicLoading, $ionicPopup) {

        $scope.limitBooks = $rootScope.allowBorrowCount;
        function init() {
            $scope.books = [];
            $scope.checked = [];//选中的图书
            $scope.groupBookIds = [];//删除所需要的参数
            $scope.myBorrowBooks;//可借本数
            $scope.flag = false;
            uiService.ionicLoadingShow({ templateTitle: '正在查询...' });
            apiService.retrieveBorrowInfo($rootScope.user.borrowID, {
                onSuccess: function (data, status, config, headers) {
                    if (data) {
                        $scope.myBorrowBooks = data.loanedBooks.length;
                        $scope.flag = true;
                        console.log(data)
                    }
                },
                onFinally: function () {
                    // 隐藏进度条
                    $ionicLoading.hide();

                }
            });
            apiService.findCartBooks($rootScope.user.borrowID, findCartBooksCallback);
        };
        var findCartBooksCallback = {
            onSuccess: function (data, status, config, headers) {
                if (data) {
                    $scope.books = data;
                    //console.log(data);
                    if ($scope.books.length == 0) {
                        $scope.showTalk = true;
                    } else {
                        $scope.showTalk = false;
                    }
                } else {
                }
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert({
                    title: '当前服务繁忙，请稍后再试',
                    okText: '确定'
                });
            }
        };
        $scope.selectOne = function () {
            angular.forEach($scope.books, function (book) {
                var index = $scope.checked.indexOf(book);
                if (book.checked && index === -1) {
                    $scope.checked.push(book);
                    $scope.groupBookIds.push(book.groupBookId);
                } else if (!book.checked && index !== -1) {
                    $scope.checked.splice(index, 1);
                    $scope.groupBookIds.splice(index, 1);
                };
            })
            console.log($scope.groupBookIds)
        }

        //删除书本
        $scope.deletebooks = function () {
            if ($scope.groupBookIds.length == 0) {
                ngCordovaService.showToast('请选择你要删除的图书');
            } else if ($scope.groupBookIds.length >= 1) {
                $ionicPopup.confirm(
                    {
                        title: '删除图书',
                        template: '真的要删除吗？',
                        cancelText: '取消',
                        okText: '确定'
                    }
                ).then(function (res) {
                    if (res) {
                        var groupBookIdsJson = angular.toJson($scope.groupBookIds);
                        //console.log(groupBookIdsJson);
                        uiService.ionicLoadingShow({ templateTitle: '正在删除所选图书...' });
                        apiService.deleteCartBooks($rootScope.user.borrowID, groupBookIdsJson, deleteActivityCallback);
                    }
                });
            }

        }
        var deleteActivityCallback = {
            onSuccess: function (data, status, config, headers) {
                ngCordovaService.showToast('删除所选图书成功');
            },
            onError: function (data, status, config, headers) {
                ngCordovaService.showToast('删除所选图书失败');
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide();

                init();
            }
        }


        $scope.goAddress = function () {
            //判断所要借阅的本数
            $scope.allBookCount = 0;
            angular.forEach($scope.checked, function (book) {
                $scope.allBookCount += book.bookCount;
            }, this);
            if ($scope.allBookCount == 0) {
                ngCordovaService.showToast('请选择你要借阅的图书');
            } else if ($scope.allBookCount >= 6) {
                $ionicPopup.alert({
                    title: '一次最多可借5本书',
                    okText: '确定'
                });
            } else {
                if ($scope.myBorrowBooks >= $scope.limitBooks) {
                    $ionicPopup.alert({
                        title: '对不起，该卡最多只能借' + $scope.limitBooks + '本书，请将其他图书归还后再借阅该图书',
                        okText: '确定',
                    });
                } else {
                    var groupBookIdsJson = angular.toJson($scope.groupBookIds);
                    $state.go('tab.orderconfirm',
                        {
                            book: $scope.checked,
                            groupBookIdsJson: groupBookIdsJson,
                        }
                    );
                }
                //}



            }


        }


        init();

        // $scope.master = true;
        // $scope.choseArr=[];//定义数组用于存放前端显示
        // var str="";//
        // var flag='';//是否点击了全选，是为a
        // $scope.x=false;
        // $scope.tesarry = [
        //     { id: 1, bookImg: 'https://img3.doubanio.com/spic/s25102626.jpg', bookTitle: '刀锋下的外交', bookAutor: '胡适', orderStatus: '代收货', orderNumber: '1111111111111' },
        //     { id: 2, bookImg: 'https://img3.doubanio.com/spic/s25102626.jpg', bookTitle: '刀锋下的外交', bookAutor: '胡适', orderStatus: '代收货', orderNumber: '1111111111111' },
        //     { id: 3, bookImg: 'https://img3.doubanio.com/spic/s25102626.jpg', bookTitle: '刀锋下的外交', bookAutor: '胡适', orderStatus: '代收货', orderNumber: '1111111111111' },
        //     { id: 4, bookImg: 'https://img3.doubanio.com/spic/s25102626.jpg', bookTitle: '刀锋下的外交', bookAutor: '胡适', orderStatus: '代收货', orderNumber: '1111111111111' },
        //     { id: 5, bookImg: 'https://img3.doubanio.com/spic/s25102626.jpg', bookTitle: '刀锋下的外交', bookAutor: '胡适', orderStatus: '代收货', orderNumber: '1111111111111' },
        //     { id: 6, bookImg: 'https://img3.doubanio.com/spic/s25102626.jpg', bookTitle: '刀锋下的外交', bookAutor: '胡适', orderStatus: '代收货', orderNumber: '1111111111111' },
        //     { id: 7, bookImg: 'https://img3.doubanio.com/spic/s25102626.jpg', bookTitle: '刀锋下的外交', bookAutor: '胡适', orderStatus: '代收货', orderNumber: '1111111111111' },
        // ];
        //var len= $scope.tesarry.length;//初始化数据長度

        // flag
        // var toChange = false;
        //
        // $scope.m = [];
        // $scope.checked = [];
        // $scope.select_all = false;
        // $scope.selectAll = function () {
        //     if ($scope.select_all == false) {
        //         angular.forEach($scope.tesarry, function (item) {
        //             item.checked = false;
        //             $scope.checked = [];
        //         });
        //         // $scope.select_all = false;
        //     } else if ($scope.select_all == true) {
        //         $scope.checked = [];
        //         angular.forEach($scope.tesarry, function (item) {
        //             item.checked = true;
        //             $scope.checked.push(item.id);
        //         });
        //         // $scope.select_all = true;
        //     }
        //     console.log("selectAll. select_all = " + $scope.select_all);
        // };
        // //$scope.select_all = false;

        //     if (item) {
        //         if (item.checked == false) {
        //             // handle all
        //             $scope.select_all = false;
        //         } else if (item.checked == true) {
        //             //
        //             $scope.checked.push(item);
        //             // handle all
        //             var select_all_tmp = true;
        //             for (var i = 0; i < $scope.tesarry.length; i++) {
        //                 if ($scope.tesarry[i].checked) {
        //                     select_all_tmp = select_all_tmp && $scope.tesarry[i].checked;
        //                 } else {
        //                     select_all_tmp = false;
        //                     // $scope.select_all = true;
        //                     break;
        //                 }
        //             }
        //             if (select_all_tmp == true) {
        //                 $scope.select_all = true;
        //             }
        //         }
        //     }

        //     // if ($scope.tesarry.length == $scope.checked.length) {
        //     //     $scope.select_all = true;
        //     // } else {
        //     //     $scope.select_all = false;
        //     // }
        //     console.log("selectOne. item is " + angular.toJson(item, true));

        // $scope.all= function (c,v) {  
        //     if(c==true){
        //         $scope.x = true;
        //         $scope.choseArr = angular.copy(v);
        //         flag = 'a'
        //     }else{
        //         $scope.x = false;
        //         $scope.choseArr = [];
        //         flag = 'b';
        //     }
        // };
        // $scope.chk = function(z,x){
        //     if(x==true){
        //         $scope.choseArr.push(z);
        //         flag = 'c';
        //         if($scope.choseArr.length==len){
        //             console.log(11111)
        //             $scope.master = true;
        //             console.log(true)
        //         }

        //     }else{
        //         $scope.choseArr.splice($scope.choseArr.indexOf(z),1);
        //     }
        //     if($scope.choseArr.length==0){                             
        //         $scope.master=false;
        //     };

        // }

        $ionicTabsDelegate.showBar(false);
    })