angular.module('starter.controllers')

    .controller('OrderReturnCtrl', function ($rootScope, $scope, $ionicSlideBoxDelegate, $state, $stateParams, $ionicPopup, $ionicLoading, apiService, uiService, $timeout, $ionicTabsDelegate, broadcastService, broadcastConstants, $ionicHistory) {
        $scope.statusMap = {
            'returning': '还书中',
            'returnFailed': '还书失败',
            'received': '已完成',
            'closed': '交易关闭',
        };
        $scope.statuses = [
            {
                value: '',
                title: '全部'
            },
            {
                value: 'returning',
                title: '还书中'
            },
            {
                value: 'received',
                title: '已完成'
            },
        ];
        $scope.expressState = { "0": "无轨迹", "1": "已揽收", "2": "在途中", "201": "到达派件城市", "3": "签收", "4": "问题件" };
        $scope.slectIndex = 0;
        $scope.pages = ["modules/order/order_return_all.html", "modules/order/order_returning.html", "modules/order/order_return_finished.html"];
        $scope.orders = [];
        $scope.waitSecondsBeforeClose = 3;
        $scope.orderNull = false;
        $scope.ASC = 'ASC';//正序
        $scope.DESC = 'DESC';//倒序
        $scope.activeSlide = function (index) {//点击时候触发
            $scope.slectIndex = index;
            $ionicSlideBoxDelegate.slide(index);
            //查看用户还书订单数量
            apiService.checkReturnOrders($rootScope.user.borrowID, {
                onSuccess: function (data, status, config, headers) {
                    if (data) {
                        var amountCount = 0;
                        if (data.returning) {
                            amountCount += parseInt(data.returning);
                        }
                        $rootScope.myReturnOrder = amountCount;
                        if ($rootScope.myReturnOrder == 0) {
                            $rootScope.returnNumberShow = false;
                        } else {
                            $rootScope.returnNumberShow = true;
                        }
                    }

                }
            });
        };
        $scope.slideChanged = function (index) {//滑动时候触发
            $scope.slectIndex = index;
            $scope.clearData();
            //查看用户还书订单数量
            apiService.checkReturnOrders($rootScope.user.borrowID, {
                onSuccess: function (data, status, config, headers) {
                    if (data) {
                        var amountCount = 0;
                        if (data.returning) {
                            amountCount += parseInt(data.returning);
                        }
                        $rootScope.myReturnOrder = amountCount;
                        if ($rootScope.myReturnOrder == 0) {
                            $rootScope.returnNumberShow = false;
                        } else {
                            $rootScope.returnNumberShow = true;
                        }
                    }

                }
            });
            if ($scope.isQueryAuto) {
                uiService.ionicLoadingShow({ templateTitle: '正在查询...' });//wsc-change
            }
            if ($scope.statuses[index].value == "returning") {
                apiService.queryReturnBookOrdersByBorrowIdAndStatus($rootScope.user.borrowID, $scope.statuses[index].value, $scope.page + 1, $scope.size, $scope.ASC, getOrderCallback);
            } else {
                apiService.queryReturnBookOrdersByBorrowIdAndStatus($rootScope.user.borrowID, $scope.statuses[index].value, $scope.page + 1, $scope.size, $scope.DESC, getOrderCallback);
            }
        }

        if (!$scope.user) {
            $state.go('tab.mine', { fromState: $ionicHistory.currentStateName() });
            return;
        }
        //订单的失败消息
        $scope.refreshFailed = false;
        $scope.refreshFailedMsg = '刷新失败，请重新下拉';
        $scope.loadMoreFailed = false;
        $scope.loadMoreFailedMsg = '加载失败';
        $scope.noMoreBooksMsg = '已经加载所有订单';
        //订单的初始数据
        $scope.orders = [];
        $scope.elementsCount = 0;
        $scope.page = -1;
        $scope.size = 4;
        $scope.totalPages = -1;
        //重置数据
        $scope.clearData = function () {
            $scope.refreshFailed = false;
            $scope.loadMoreFailed = false;
            $scope.elementsCount = 0;
            $scope.orders = [];
            $scope.totalPages = -1;
            $scope.page = -1;
            $scope.loadStatus == 'idel'; // 'idel', 'loading', 'finished:success/failed';
        };
        //下拉刷新
        $scope.refresh = function () {
            // 刷新重置数据
            $scope.clearData();
            //
            init();
        };
        // 加载更多
        $scope.loadMore = function (ignoreLoadMoreFailed) {
            if ($scope.refreshFailed) {
                console.warn('加载首页订单，加载下一页只能在之前加载成功的情况下进行。');
                return;
            }
            if ($scope.loadMoreFailed) {
                if (ignoreLoadMoreFailed) {
                } else {
                    console.warn('上次加载更多订单失败，加载下一页只能在之前加载成功的情况下进行。');
                    return;
                }
            }
            //
            // 只要首页查询成功，page就已经是0了。
            if ($scope.page >= 0 && $scope.page < $scope.totalPages - 1) {
                $scope.loadMoreFailed = false;
                init();
            } else {
                console.warn('查询所有订单列表，当前已经是最后一页，不需要加载下一页。');
            }

        };
        var getOrderCallback = {
            onSuccess: function (data, status, config, headers) {
                if (data) {
                    $scope.loadStatus = 'success';
                    if ($scope.page == -1) {                    // 下拉：首页
                        $scope.refreshFailed = false;
                    } else {                                    // 上拉：原始页码大于等于0
                        $scope.loadMoreFailed = false;
                    }
                    // // 查询成功，赋值数据
                    $scope.elementsCount = data.elementsCount;
                    $scope.totalPages = data.totalPages;
                    $scope.page = $scope.page + 1;
                    $scope.orders = $scope.orders.concat(data.data);
                    console.log($scope.orders)
                    if ($scope.orders.length == 0 && $scope.statuses[$scope.slectIndex].value == "") {
                        $scope.orderNull = true;
                    }
                }
            },
            onError: function (data, status, config, headers) {
                $scope.loadStatus = 'failed';
                $ionicPopup.alert({
                    title: '当前服务繁忙，请稍后再试',
                    okText: '确定'
                });
            },
            /*********wsc-change*********/
            onFinally: function () {
                // 隐藏进度条
                if ($scope.isQueryAuto == true) {
                    $scope.$broadcast('scroll.refreshComplete');
                } else {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
                if ($scope.isQueryAuto) {
                    $scope.isQueryAuto = false;
                    $ionicLoading.hide();
                } else {
                    if ($scope.page == -1) { // 首页查询失败
                        $scope.$broadcast('scroll.refreshComplete');
                    } else if ($scope.page == 0 && !$scope.refreshFailedAll) { // 首页查询成功
                        $scope.$broadcast('scroll.refreshComplete');
                    } else if ($scope.page == 0 && $scope.loadMoreFailedAll) { // 第一次更多查询失败
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    } else if ($scope.page > 0) {                           // 第n>1次查询更多
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    }
                }
            }
        };

        //查询物流
        $scope.obtainTrace = function (expressId) {
            uiService.ionicLoadingShow({ templateTitle: '正在查询...' });
            apiService.obtainTraceByExpressId(expressId, obtainTraceCallback);
        };
        var obtainTraceCallback = {
            onSuccess: function (data, status, config, headers) {
                //console.log(data)
                if (data && data.response) {
                    $scope.trace = JSON.parse(data.response);
                    $scope.showExpressTrace();
                } else {
                    msg = '当前服务繁忙，请稍后再试';
                }
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert({
                    title: '当前服务繁忙，请稍后再试',
                    okText: '确定'
                });
            },
            onFinally: function () {
                // 隐藏进度条
                $ionicLoading.hide().then(function () {
                    console.log("The loading indicator is now hidden");
                });
            }
        };
        $scope.showExpressTrace = function () {
            $ionicPopup.show({
                templateUrl: 'modules/order/express_trace.html',
                title: '查看物流',
                scope: $scope,
                buttons: [
                    {
                        text: '<b>确认</b>',
                        type: 'button-small button-positive'
                    }
                ]
            });
        };
        $scope.currentState = $ionicHistory.currentStateName();
        if ($scope.currentState == 'tab.homeorderreturn') {
            $scope.goOrderReturnDetail = function (order) {
                $state.go('tab.homeorder_return_detail', { order: order });
            }
        }else if($scope.currentState == 'tab.orderreturn') {
            $scope.goOrderReturnDetail = function (order) {
                $state.go('tab.order_return_detail', { order: order });
            }
        }else if($scope.currentState == 'tab.discoveryorderreturn') {
            $scope.goOrderReturnDetail = function (order) {
                $state.go('tab.discoveryorder_return_detail', { order: order });
            }
        }else {
            $scope.goOrderReturnDetail = function (order) {
                $state.go('tab.bookhomeorder_return_detail', { order: order });
            }
        }
        //初始化
        function init() {
            if ($scope.loadStatus == 'loading' || $scope.loadStatus == 'failed') {
                console.warn('load page ' + ($scope.page + 1) + ' unfinished, waitting please...');
                return;
            }
            if ($scope.slectIndex != undefined && !isNaN($scope.slectIndex)) {
                //
            } else {
                // var index = _.indexOf($scope.tabNames, $stateParams.to);
                var index = -1;
                for (var i in $scope.statuses) {
                    var status = $scope.statuses;
                    if (!_.isEmpty(status)) {
                        if ($stateParams.to == status.title) {
                            index = i;
                            break;
                        }
                    }
                }
                $scope.slectIndex = index === -1 ? 0 : index;
            }
            //查看用户还书订单数量
            apiService.checkReturnOrders($rootScope.user.borrowID, {
                onSuccess: function (data, status, config, headers) {
                    if (data) {
                        console.log(data)
                        var amountCount = 0;
                        if (data.returning) {
                            amountCount += parseInt(data.returning);
                        }
                        $rootScope.myReturnOrder = amountCount;
                        if ($rootScope.myReturnOrder == 0) {
                            $rootScope.returnNumberShow = false;
                        } else {
                            $rootScope.returnNumberShow = true;
                        }
                    }

                }
            });
            $scope.loadStatus = 'loading';
            if ($scope.isQueryAuto) {
                uiService.ionicLoadingShow({ templateTitle: '正在查询...' });//wsc-change
            }
            if ($scope.statuses[$scope.slectIndex].value == "returning") {
                apiService.queryReturnBookOrdersByBorrowIdAndStatus($rootScope.user.borrowID, $scope.statuses[$scope.slectIndex].value, $scope.page + 1, $scope.size, $scope.ASC, getOrderCallback);
            } else {
                apiService.queryReturnBookOrdersByBorrowIdAndStatus($rootScope.user.borrowID, $scope.statuses[$scope.slectIndex].value, $scope.page + 1, $scope.size, $scope.DESC, getOrderCallback);
            }

        };








        $scope.isQueryAuto = true;
        $scope.refresh();//主动刷新一次

        $ionicTabsDelegate.showBar(false);
    })