angular.module('starter.controllers')

    .controller('YouchooseIpayCtrl', function ($scope, $state, $ionicSlideBoxDelegate, $ionicHistory, $ionicPopup, $ionicLoading, $cordovaBarcodeScanner, apiService, uiService, ngCordovaService, $ionicTabsDelegate, $ionicActionSheet, broadcastService, broadcastConstants) {
        $scope.tabNames = ['我提交的', '我要选书'];
        $scope.slectIndex = 0;
        $scope.activeSlide = function (index) {//点击时候触发
            $scope.slectIndex = index;
            $ionicSlideBoxDelegate.slide(index);
        };
        $scope.slideChanged = function (index) {//滑动时候触发
            $scope.slectIndex = index;
        };
        $scope.pages = ["modules/youchooseipay/ycip_isubmitted.html", "modules/youchooseipay/ycip_ichoose.html"];



        // ----------------------------------------------------------------------------------------------------
        $scope.bookStores = [];

        // ----------------------------------------------------------------------------------------------------
        // 获取所有合作书店信息
        $scope.isRetrievingAllBookStores = false;
        $scope.retrieveAllBookStores = function () {
            if ($scope.isRetrievingAllBookStores) {
                return;
            }
            $scope.isRetrievingAllBookStores = true;
            uiService.ionicLoadingShow({ templateTitle: '正在查询...' });
            apiService.retrieveAllBookStores(retrieveAllBookStoresCallback)
        };
        var retrieveAllBookStoresCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.bookStores = data;
            },
            onError: function (data, status, config, headers) {

            },
            onFinally: function () {
                $scope.isRetrievingAllBookStores = false;
                if ($scope.isRetrievingMyBookChoosings == false) {
                    $ionicLoading.hide();
                }
            }
        };



        // ----------------------------------------------------------------------------------------------------
        $scope.myBookChoosings = [];
        $scope.tmpBookChoosing = { isbn: '111111' };



        // ----------------------------------------------------------------------------------------------------
        // 获取“我”的所有推荐图书
        $scope.isRetrievingMyBookChoosings = false;
        $scope.retrieveMyBookChoosings = function (slient) {
            if ($scope.isRetrievingMyBookChoosings) {
                return;
            }
            $scope.isRetrievingMyBookChoosings = true;
            if (slient == true) {
                //
            } else {
                uiService.ionicLoadingShow({ templateTitle: '正在查询..' });
            }
            apiService.retrieveUserBookChoosings($scope.user.account, retrieveUserBookChoosingsCallback);
        }
        var retrieveUserBookChoosingsCallback = {
            onSuccess: function (data, status, config, headers) {
                $scope.myBookChoosings = data;
            },
            onError: function (data, status, config, headers) {

            },
            onFinally: function () {
                $scope.isRetrievingMyBookChoosings = false;
                if ($scope.isRetrievingAllBookStores == false) {
                    $ionicLoading.hide();
                }
            }
        };
        // ----------------------------------------------------------------------------------------------------
        // 添加推荐图书
        $scope.newBookChoosing = function () {
            $ionicActionSheet.show({
                buttons: [
                    { text: '扫描图书ISBN条码' },
                    { text: '输入图书ISBN条码' }
                ],
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:
                            $cordovaBarcodeScanner.scan()
                                .then(
                                function (result) {
                                    // alert("We got a barcode\n" +
                                    //     "Result: " + result.text + "\n" +
                                    //     "Format: " + result.format + "\n" +
                                    //     "Cancelled: " + result.cancelled);
                                    uiService.ionicLoadingShow({ templateTitle: '正在处理...' });//wsc-change
                                    apiService.retrieveDoubanBookInfo(result.text, retrieveDoubanBookInfoCallback);
                                    // trace
                                    $scope.tmp = {};
                                    $scope.tmp.BookISBN = result.text;
                                },
                                function (error) {
                                    consolog.warn("Scanning failed: " + error);
                                    ngCordovaService.showToast('摄像头可能正在使用中，请稍后再试...');
                                }
                                );
                            break;
                        case 1:
                            $scope.tmp = {};
                            $scope.tmp.BookISBN = null;
                            $ionicPopup.confirm(
                                {
                                    title: '手动输入图书ISBN信息',
                                    template: '<label class="item item-input"><span class="input-label">ISBN</span><input type="number" ng-model="tmp.BookISBN"/></label>',
                                    scope: $scope,
                                    cancelText: '取消',
                                    okText: '确定'
                                }
                            ).then(function (res) {
                                if (res) {
                                    uiService.ionicLoadingShow({ templateTitle: '正在处理...' });//wsc-change
                                    apiService.retrieveDoubanBookInfo($scope.tmp.BookISBN, retrieveDoubanBookInfoCallback);
                                } else {
                                    $scope.tmp = undefined;
                                }
                            });
                            break;
                        default:
                            break;
                    };
                    return true;
                }
            });
        };
        var retrieveDoubanBookInfoCallback = {
            onSuccess: function (data, status, config, headers) {
                if (data) {
                    $scope.tmpDoubanBookInfo = data;
                    $ionicPopup.confirm(
                        {
                            title: '推荐图书',
                            templateUrl: 'modules/youchooseipay/ycip_bc_new.html',
                            scope: $scope,
                            cancelText: '取消',
                            okText: '确定'
                        }
                    ).then(function (res) {
                        if (res) {
                            uiService.ionicLoadingShow({ templateTitle: '正在推荐图书..' });
                            apiService.newBookChoosing(
                                {
                                    userId: $scope.user.account,
                                    isbn: $scope.tmpDoubanBookInfo.isbn
                                },
                                newBookChoosingCallback
                            );
                        } else {
                            $scope.tmpDoubanBookInfo = null;
                        }
                    });
                    /****************wsc-change*****************/
                    //发送广播
                    broadcastService.send(
                        broadcastConstants.names.onDeleteBookChoosingChanged,
                        {
                            operation: 'deleteBookChoosing',
                            result: 'success',
                            isbn: $scope.tmpDoubanBookInfo.isbn,
                        }
                    );
                } else {
                    var title = '';
                    if (!$scope.tmp || !$scope.tmp.BookISBN) {
                        title = '未找到与该ISBN匹配的书籍';
                    } else {
                        title = '未找到与该ISBN（' + $scope.tmp.BookISBN + '）匹配的书籍';
                    }
                    $ionicPopup.alert(
                        {
                            title: title,
                            okText: '确定'
                        }
                    );
                }
            },
            onError: function (data, status, config, headers) {
                var title = '';
                if (!$scope.tmp || !$scope.tmp.BookISBN) {
                    title = '未找到与该ISBN匹配的书籍';
                } else {
                    title = '未找到与该ISBN（' + $scope.tmp.BookISBN + '）匹配的书籍';
                }
                $ionicPopup.alert(
                    {
                        title: title,
                        okText: '确定'
                    }
                );
            },
            /******************************wsc-change*****************************/
            onFinally: function () {
                $ionicLoading.hide();
            }
        };
        var newBookChoosingCallback = {
            onSuccess: function (data, status, config, headers) {
                apiService.retrieveUserBookChoosings($scope.user.account, retrieveUserBookChoosingsCallback); // 刷新所有推荐图书
                $ionicPopup.alert(
                    {
                        title: '推荐成功',
                        okText: '确定'
                    }
                );
                /****************wsc-change*****************/
                //发送广播
                broadcastService.send(
                    broadcastConstants.names.onDeleteBookChoosingChanged,
                    {
                        operation: 'deleteBookChoosing',
                        result: 'success',
                        isbn: $scope.tmpDoubanBookInfo.isbn,
                    }
                );
            },
            onError: function (data, status, config, headers) {
                $ionicPopup.alert(
                    {
                        title: '推荐失败',
                        okText: '确定'
                    }
                );
            },
            onFinally: function () {
                $scope.tmpBookChoosing = null;
                $ionicLoading.hide();
            }
        };

        // // ----------------------------------------------------------------------------------------------------
        // function updateBookChoosing(updateBookChoosingCallback) {

        // }
        // var updateBookChoosingCallback = {
        //     onSuccess: function (data, status, config, headers) {

        //     },
        //     onError: function (data, status, config, headers) {

        //     }
        // };




        // ----------------------------------------------------------------------------------------------------
        $scope.currentState = $ionicHistory.currentStateName();
        if ($scope.currentState == 'tab.youchooseipay') {
            $scope.goBookChoosingDetail = function (bookChoosing) {
                $state.go('tab.youchooseipay_ic_book_detail',
                    {
                        book: bookChoosing,
                        recommendedId: bookChoosing.id,
                    }
                );
            };
            $scope.goBookStore = function (bookStore) {
                $ionicHistory.clearCache().then(
                    function () {
                        $state.go('tab.youchooseipay_books_in_store', { bookStore: bookStore });
                    }
                );
            };
        } else {
            $scope.goBookChoosingDetail = function (bookChoosing) {
                $state.go('tab.mineyouchooseipay_ic_book_detail', { book: bookChoosing });
            };
            $scope.goBookStore = function (bookStore) {
                $ionicHistory.clearCache().then(
                    function () {
                        $state.go('tab.mineyouchooseipay_books_in_store', { bookStore: bookStore });
                    }
                );
            };
        }

        /******************wsc-change**************************/
        var onDeleteBookChoosingChangedListener = function () {
            //console.log('BookHomeBooksCtrl', angular.toJson(data, true));
            $scope.retrieveMyBookChoosings(true);
        };
        broadcastService.register(broadcastConstants.names.onDeleteBookChoosingChanged, onDeleteBookChoosingChangedListener);
        $scope.$on('$destroy', function () {
            broadcastService.unregister(broadcastConstants.names.onDeleteBookChoosingChanged, onDeleteBookChoosingChangedListener);
        });
        // ----------------------------------------------------------------------------------------------------
        if (!$scope.user) {
            $state.go('tab.mine');
        } else {
            $scope.retrieveMyBookChoosings();
            $scope.retrieveAllBookStores();
        }
        $ionicTabsDelegate.showBar(false);
    });
